function [resample_index] = SR(w)
%index finding by systematic resampling according to
%the importance weights given in w vector
%
%by Deniz Gencaga,2004.

N=length(w);%particle number



resamp_index=zeros(N,1);

u=(1/N)*rand(1,1);

s=0;

for i=1:N;
    
    k=0;
    
    s=s+w(i);
    
    while s>u;
        
        k=k+1;
                
        
        u=u+1/N;
        
    end
    
    resample_index(i)=k;
    
   
    
end




    
    
    
    
    
    
   
